/* $Id: mach64_vga.h,v 1.4 1999/06/27 16:01:15 marcus Exp $
******************************************************************************

   ATI Mach64 Series -- structures to hold state/IO information

   Copyright (C) 1997		Simon Hammett

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

/* Change Log:
 *
 * Tue  Jan 20th 1998	v1.0.4	added Mach64_Get_Vga_State.
 * Wen	Jan  7th 1998	v1.0.3	copied text16_ stuff over, prototype for
 *				set_mode_text16.
 * Sat	Dec 13th 1997	v1.0.2	Prototypes for vga mode timing stuff,
 *				setting up as a000 text base @ 128 kb size
 * Fri  Dec 12th 1997	v1.0.1	Added reg save struct
 * Fri  Dec  5th 1997	v1.0	File Creation
 *
 */

#ifndef	_MACH64_VGA_H__
#define	_MACH64_VGA_H__

#warning >-- Using defines for text mode, CHECK for values!!! --<
#define	TEXT16_LFB_BASE	0xa0000
#define	TEXT16_LFB_SIZE	64 KB

/*-- these should be moved to vga.h */

#ifndef	NoSEQRegs

	#define	NoSEQRegs	0x05
	#define	NoCRTRegs	0x19
	#define	NoGRCRegs	0x09
	#define	NoATCRegs	0x15

#endif

#define	CRTI	CRTIc
#define	CRTD	CRTDc
#define	INS1r	INS1rc

typedef	struct	{
			kgiu8	Misc;
			kgiu8	Seq[ NoSEQRegs ];
			kgiu8	Crt[ NoCRTRegs ];
			kgiu8	Grc[ NoGRCRegs ];
			kgiu8	Atc[ NoATCRegs ];
		}VGA_State_Table;

#ifdef	_MACH64_VGA_C__

	VGA_State_Table	Mach64_VGA_State;
	VGA_State_Table	Mach64_VGA_Default =
	{
		0x23,					/* MISC	*/
		{					/* SEQ */
			0x03, 0x00, 0x00, 0x00, 0x00
		},
		{					/* CRT */
			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF,
			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	/* 0x1x	*/
			0x00
		},
		{					/* GRC */
			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			0xFF
		},
		{					/* ATC */
			0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
			0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
			0x20, 0x00, 0x0F, 0x00, 0x00
		}
	};

	struct	mem_region	Mach64_VGA_Mem =
				{
					MEM_NULL,
					TEXT16_LFB_BASE,
					TEXT16_LFB_SIZE,
					-1,
					"Mach64 VGA Memory"
				};

	int	text16_origin;

	#define	VGA_CLK_MIN	25000000
	#define	VGA_CLK_MAX	32000000

#else

	extern	VGA_State_Table		Mach64_VGA_State;
	extern	struct mem_region	Mach64_VGA_Mem;

#endif



/*
 * prototypes
 */

int	Mach64_Clock_Raise_VGA( struct kgi_display *dpy, struct kgi_mode *mode );
int	Mach64_Clock_Lower_VGA( struct kgi_display *dpy, struct kgi_mode *mode );
void    Mach64_Adjust_Timing_Values_VGA( struct kgi_mode *mode );

void	Mach64_Save_VGA_State( VGA_State_Table *vss );
void	Mach64_Restore_VGA_State( VGA_State_Table *vss );
int	Mach64_Get_VGA_State( struct kgi_display *dpy );
void	Mach64_Setup_Display_Text16( struct kgi_display *dpy,
		struct kgi_mode *mode, int x, int y );

int	Mach64_Propose_Mode_Text16( struct kgi_mode *mode );
int	Mach64_Check_Mode_Text16( struct kgi_mode *mode );
int	Mach64_Set_Mode_Text16( struct kgi_display *dpy, struct kgi_mode *mode );

void	text16_set_origin( struct kgi_display *dpy, uint x, uint y );
void	text16_set_split( struct kgi_display *dpy, int line );
void	text16_set_font( struct kgi_display *dpy, struct kgi_font *font,
				uint from, uint to );

#define	text16_set_frame	NULL

void	text16_show_cursor( struct kgi_display *dpy, uint x, uint y );
void	text16_hide_cursor( struct kgi_display *dpy );

#define text16_undo_cursor      text16_hide_cursor

#endif
